package dk.vajhoej.record.test;

import org.junit.Test;

import com.tngtech.archunit.core.domain.JavaClasses;
import com.tngtech.archunit.core.importer.ClassFileImporter;

import static com.tngtech.archunit.lang.syntax.ArchRuleDefinition.classes;
import static com.tngtech.archunit.lang.syntax.ArchRuleDefinition.noClasses;
import static com.tngtech.archunit.lang.syntax.ArchRuleDefinition.methods;

public class TestArchitecture {
	private static final String MOD_PASCAL_CASE = "([A-Z]+[a-z0-9]*)+";
	private static final String MOD_CAMEL_CASE = "[a-z][a-z0-9]*([A-Z]+[a-z0-9]*)*";
	private static final String DIGITS = "[0-9]+";
	private static final String ARTIFICIAL_METHOD = "\\$.*";
	private static final String OUTER_CLZ_NAM_PAT = MOD_PASCAL_CASE;
	private static final String INNER_CLZ_NAM_PAT = "\\$(" + OUTER_CLZ_NAM_PAT + "|" + DIGITS + ")";
	private static final String CLZ_NAM_PAT = OUTER_CLZ_NAM_PAT + "(" + INNER_CLZ_NAM_PAT + ")*";
	private static final String METH_NAM_PAT = MOD_CAMEL_CASE + "|" + ARTIFICIAL_METHOD;
	private JavaClasses thislib = new ClassFileImporter().importPackages("dk.vajhoej.record", "dk.vajhoej.record8");
	@Test
	public void testNamingConventionClasses() {
		classes().that().resideInAnyPackage("dk.vajhoej.record").should().haveNameMatching("dk.vajhoej.record." + CLZ_NAM_PAT).check(thislib);
		classes().that().resideInAnyPackage("dk.vajhoej.record8").should().haveNameMatching("dk.vajhoej.record8." + CLZ_NAM_PAT).check(thislib);
	}
	@Test
	public void testNamingConventionMethods() {		
		methods().that().areDeclaredInClassesThat().resideInAnyPackage("dk.vajhoej.record", "dk.vajhoej.record8").should().haveNameMatching(METH_NAM_PAT).check(thislib);;
	}
	@Test
	public void testLayers() {
		noClasses().that().resideInAnyPackage("dk.vajhoej.record").should().dependOnClassesThat().resideInAnyPackage("dk.vajhoej.record8").check(thislib);
	}
}
